<?php

class ama_popupcamp {

    public function __construct() {
        add_action('init', array(&$this, 'init'));
        add_action('add_meta_boxes', array(&$this, 'addAmazonbox'));
    }

    public function addAmazonbox() {
        add_meta_box(
                'amazonbox', 'WP Amaz One', array($this, 'amazonMetabox'), 'page', 'side', 'core'
        );
        add_meta_box(
                'amazonbox', 'WP Amaz One', array($this, 'amazonMetabox'), 'post', 'side', 'core'
        );
        add_meta_box(
                'amazonlinkbox', 'Link Generator', array($this, 'amazonMetalink'), 'page', 'advanced', 'core'
        );
        add_meta_box(
                'amazonlinkbox', 'Link Generator', array($this, 'amazonMetalink'), 'post', 'advanced', 'core'
        );
    }

    public function amazonMetalink(){
        include_once 'pages/ama_linkmeta.php';
    }

    public function campPro() {
        global $wpdb;
        if (isset($_POST['btnsubmit']) && isset($_POST['delete']) && count($_POST['delete']) > 0) {
            $id = implode(',', $_POST['delete']);
            $sql = "DELETE FROM `" . $wpdb->prefix . "ama_camp_prodata` WHERE id IN (" . $id . ")";
            $wpdb->query($sql);
        }
        if (isset($_GET['mode']) && $_GET['mode'] == "delete" && isset($_GET['prid'])) {
            $sql = "DELETE FROM `" . $wpdb->prefix . "ama_camp_prodata` WHERE id='" . $_GET['prid'] . "'";
            $wpdb->query($sql);
        }
        include_once 'pages/camp_pop_list.php';
    }

    public function amazonMetabox() {
        global $wpdb;
        ?>
        <div>
            <div>
                <lable style="font-size: 15px;"><b>Button Format</b></lable><br/>
                Button 1&nbsp;&nbsp;:&nbsp;&nbsp;<img src="<?php echo AMAZON_URL ?>images/button1.png" alt="button1" style="vertical-align: middle;" /><br>
                Button 2&nbsp;&nbsp;:&nbsp;&nbsp;<img src="<?php echo AMAZON_URL ?>images/button2.png" alt="button2" style="vertical-align: middle;" /><br>
                Button 3&nbsp;&nbsp;:&nbsp;&nbsp;<img src="<?php echo AMAZON_URL ?>images/button3.png" alt="button3" style="vertical-align: middle;" /><br>
                Button 4&nbsp;&nbsp;:&nbsp;&nbsp;<img src="<?php echo AMAZON_URL ?>images/button4.png" alt="button4" style="vertical-align: middle;" /><br>
                Button 5&nbsp;&nbsp;:&nbsp;&nbsp;<img src="<?php echo AMAZON_URL ?>images/button5.png" alt="button5" style="vertical-align: middle;" /><br>
            </div>
            <div>
                <lable style="font-size: 15px;"><b>Post Format</b></lable>
                <br/>
                <br/>
                <a class="tooltipAmazon" href="#">Format 1<span><img src="<?php echo AMAZON_URL ?>images/format1.jpg"  style="vertical-align: middle;"></span></a><br/>
                <br/>
                <a class="tooltipAmazon" href="#">Format 2<span><img src="<?php echo AMAZON_URL ?>images/format2.jpg"  style="vertical-align: middle;"></span></a><br/>
                <br/>
                <a class="tooltipAmazon" href="#">Format 3<span><img src="<?php echo AMAZON_URL ?>images/format3.jpg"  style="vertical-align: middle;"></span></a><br/>
                <br/>
            </div>
            <div>
                <?php
                $sql = "SELECT keyword FROM `" . $wpdb->prefix . "ama_popcamp`";
                $result = $wpdb->get_results($sql);
                if ($result) {
                    ?>
                    <b><lable style="font-size: 15px;">Text Link Campaign Note</lable></b><br/><br/><i><b><small>To create popups on this post, add custom field "amazon_popup_keyword"</small></b></i><br/><br/>
                    <b><lable style="font-size: 13px;">Text Link Campaign Keywords</lable></b><br/><br/>
                    <?php
                    $conkeyword = "";
                    foreach ($result as $keyword) {
                        $conkeyword.=$keyword->keyword . ',';
                    }
                    echo trim($conkeyword, ",");
                }
                ?>
            </div>
        </div>

        <?php
    }

    public function init() {
        wp_enqueue_script('jquery');
        wp_enqueue_style("ama-thickbox-style-2", AMAZON_URL . "css/ajax-tooltip.css");
        wp_enqueue_script("ama-hover-script", AMAZON_URL . "js/ajax.js");
        wp_enqueue_script("ama-bgiframe-script", AMAZON_URL . "js/ajax-dynamic-content.js");
        wp_enqueue_script("ama-cluetip-script", AMAZON_URL . "js/ajax-tooltip.js");
    }

    public function addCamp() {
        global $wpdb;

        if (isset($_POST['submit'])) {
            $arrRemove = array('submit');
            $saveData = array();
            foreach ($_POST as $key => $value) {
                if (in_array($key, $arrRemove))
                    continue;
                $saveData[$key] = $value;
            }
            $insertid = ama_save_campaign($saveData, "ama_popcamp");
            if ($insertid) {
                ama_popupcamp::get_product($_POST['keyword'], $_POST['department'], $_POST['affid'], $insertid);
            }
        }
        include_once 'pages/addpopup.php';
    }

    public function listCamp() {
        global $wpdb;
        if (isset($_GET['mode']) && $_GET['mode'] == "delete") {
            $sql = "DELETE FROM `" . $wpdb->prefix . "ama_popcamp` WHERE id='" . $_GET['id'] . "'";
            $wpdb->query($sql);
            $sql = "DELETE FROM `" . $wpdb->prefix . "ama_camp_prodata` WHERE campid='" . $_GET['id'] . "' AND 	camtype=1 ";
            $wpdb->query($sql);
        }
        include_once 'pages/popupcamp_list.php';
    }

    function get_product($keyword, $department, $AffiliateId, $insertid) {
        @ini_set('memory_limit', '256M');
        @set_time_limit(0);
        global $wpdb;
        $data_product = array();
        $count = 0;
        $sql = "select * from " . $wpdb->prefix . "ama_option ";
        $api_data = $wpdb->get_results($sql);
        foreach ($api_data as $apidata) {
            $PublicKey = $apidata->api_key;
            $PrivateKey = $apidata->secret_api_key;
            $des_length = $apidata->amazon_des_length;
            $aff_web = $apidata->amazon_web;
        }
        $first_count = 0;
        $error_count = 0;
        $error_message = "";
        $product_error = "";
        $countpost = array();
        $finished = false;
        $page = 1;
        $post_ID = 0;
        $pagecontent = "";
        do {
            usleep(1200000);
            if ($department == "All") {
                $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                    "IdType" => "ASIN",
                    "MerchantId" => "All",
                    "ResponseGroup" => "EditorialReview,Small,OfferListings,Images,VariationSummary",
                    "SearchIndex" => $department,
                    "Keywords" => $keyword,
                    "ItemPage" => $page,
                    "AssociateTag" => $AffiliateId), $aff_web);
            } else {
                $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                    "IdType" => "ASIN",
                    "MerchantId" => "All",
                    "ResponseGroup" => "EditorialReview,Small,OfferListings,Images,VariationSummary",
                    "SearchIndex" => $department,
                    "Keywords" => $keyword,
                    "ItemPage" => $page,
                    "AssociateTag" => $AffiliateId), $aff_web);
            }
            if (isset($xml->Items->Request->Errors->Error->Code) || isset($xml->Error->Code) || isset($xml['error']['message'])) {
                if (isset($xml->Items->Request->Errors->Error->Code)) {
                    $error_message['message'] = '<b>' . $xml->Items->Request->Errors->Error->Code . ' -- ' . $xml->Items->Request->Errors->Error->Message . '</b>';
                      if ($xml->Items->Request->Errors->Error->Code == 'AWS.InvalidAccount') { $error_message['message'] .= ' <a href="https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html">Click here to follow link</a>';}
                } elseif (isset($xml->Error->Code)) {
                   $error_message['message'] = '<b>' . $xml->Error->Code . ' -- ' . $xml->Error->Message . '</b><br/>';
                }
                 else {
                    $error_message['message'] = '<b>Host not found</b>';
                }
                $finished = true;
            } else {

                foreach ($xml->Items->Item as $item) {
                    $LowestPrice = ama_getamazonprice($item);

                    $pricetypearray = array('$', '£', 'EUR', ',', 'CDN', '￥', "Â");
                    $price = (float) str_replace($pricetypearray, '', $LowestPrice);
                    if (isset($item->EditorialReviews->EditorialReview->Content) && isset($item->MediumImage->URL) && $LowestPrice != null) {
                        if($item->Offers->TotalOffers == 0) {
                            $buylink = $item->DetailPageURL;
                        } else {
                            $buylink = 'http://www.amazon.' . $aff_web . '/gp/aws/cart/add.html?ASIN.1=' . $item->ASIN . '&Quantity.1=1&AssociateTag=' . $AffiliateId . '&AWSAccessKeyID=' . $PublicKey;
                        }
                        $arrayInsert = array(
                            'campid' => $insertid,
                            'asin' => $item->ASIN,
                            'title' => $item->ItemAttributes->Title[0],
                            'link' => $buylink,
                            'price' => $LowestPrice,
                            'des' => strip_tags($item->EditorialReviews->EditorialReview->Content),
                            'imgurl' => $item->MediumImage->URL[0],
                            'clockurl' => get_bloginfo('home') . "/amazone/" . $item->ASIN,
                            'web' => $aff_web,
                            'affid' => $AffiliateId,
                            'camtype' => '1'
                        );

                        ama_save_campaign($arrayInsert, "ama_camp_prodata");
                        $count++;
                    }
                    if ($count >= 10) {
                        $finished = true;
                        break;
                    }
                }
                if($department == 'All') $maxpagesallowed = 5;
                else $maxpagesallowed = 10;
                if ($page >= $maxpagesallowed) {
                    $finished = true;
                    break;
                }
            }
            $page++;
        } while (!($finished));
        if ($error_message['message'] != "") {
            $sql = "DELETE FROM `" . $wpdb->prefix . "ama_popcamp` WHERE id='" . $insertid . "'";
            $wpdb->query($sql);
            echo '<div class="updated" style="margin:0px"><p>' . $error_message['message'] . '</p></div>';
        } else {
            echo '<div class="updated" style="margin:0px"><p>Popup Campaign created successfully.</p></div>';
        }
    }

    public function replaceContent($content = false) {

        global $wpdb, $post;
        $metaPop = get_post_meta($post->ID, 'amazon_popup_keyword', true);
        if ($metaPop) {
            $arrKeyword = explode(',', $metaPop);
            if ($arrKeyword && is_array($arrKeyword) && count($arrKeyword) > 0) {
                for ($i = 0; $i < count($arrKeyword); $i++) {
                    $sql = "SELECT * FROM `" . $wpdb->prefix . "ama_popcamp` WHERE keyword LIKE '%" . trim($arrKeyword[$i]) . "%'";
                    $result = $wpdb->get_row($sql);
                    $ajaxLink = AMAZON_URL . 'ajax.php?height=300&width=350&campid=' . $result->id;
                    if ($result) {
                        $onmouseout = "onmouseout=ajax_hideTooltip('10')";
                        $onmouseover = "onmouseover=ajax_showTooltip(window.event,'" . $ajaxLink . "',this,'" . AMAZON_URL . "');return false";
                        $anchorTag = "<a rel='nofollow' href='#'  $onmouseover $onmouseout  >$result->keyword</a>";
                        $content = ama_popupcamp::conver_ascii($content);
                        $arraycontent = ama_popupcamp::explodei($result->keyword, $content, ($result->numpop + 1));
                        $content = implode($anchorTag, $arraycontent);
                        $content = ama_popupcamp::de_conver_ascii($content);
                    }
                }
            }
        }
        return $content;
    }

    public function conver_ascii($string) {
        for ($i = 0; $i < strlen($string); $i++) {
            $imagetag = strtolower($string[$i + 1] . $string[$i + 2] . $string[$i + 3]);
            $inputtag = strtolower($string[$i + 1] . $string[$i + 2] . $string[$i + 3] . $string[$i + 4] . $string[$i + 5]);
            if ($string[$i] == "<" && (strtolower($string[$i + 1]) == "a" || strtolower($string[$i + 1]) == "p" || $imagetag == "img" || $imagetag == "div" || $inputtag == "input")) {
                $script = 1;
            }
            if ($script == 1) {
                if ($string[$i] == "<") {
                    $obscure .= $string[$i];
                } elseif ($string[$i] == ">") {
                    $obscure .= $string[$i];
                } else {
                    $obscure .= '#&' . ord($string[$i]);
                }
            } else {
                $obscure .= $string[$i];
            }
            if ($string[$i] == ">" && $script == 1) {
                $script = 0;
            }
        }

        return $obscure;
    }

    public function de_conver_ascii($string) {
        for ($i = 0; $i < strlen($string); $i++) {
            if ($string[$i] == "<" && $string[$i + 1] == "#") {
                $script = 1;
                $stringdata = "";
                $newstring = "";
            }
            if ($script == 1) {
                if ($string[$i] != "<" && $string[$i] != ">") {
                    $stringdata.= $string[$i];
                }
            } else {
                $obscure .= $string[$i];
            }
            if ($string[$i] == ">" && $script == 1) {
                $arrStringdata = explode("#&", $stringdata);
                for ($j = 1; $j < count($arrStringdata); $j++) {
                    $newstring.=chr($arrStringdata[$j]);
                }
                $obscure.='<' . $newstring . '>';
                $script = 0;
            }
        }
        return $obscure;
    }

    public function explodei($separator, $string, $limit = false) {
        $len = strlen($separator);
        for ($i = 0;; $i++) {
            if (($pos = stripos($string, $separator)) === false || ($limit !== false && $i > $limit - 2 )) {
                $result[$i] = $string;
                break;
            }
            $result[$i] = substr($string, 0, $pos);
            $string = substr($string, $pos + $len);
        }
        return $result;
    }

}

new ama_popupcamp();
?>
