<?php

include_once 'youtube.inc.php';

function ama_aws_request($PrivateKey, $PublicKey, $parameters, $amz_region, $Version = "2009-03-31") { //this is the function that does the api request
    libxml_use_internal_errors(true);
    $uri = "/onca/xml";
    $host = "ecs.amazonaws." . $amz_region;
    $method = "GET";
    $t = time() + 10000;
    $parameters["Timestamp"] = gmdate("Y-m-d\TH:i:s\Z", $t);
    $parameters["AWSAccessKeyId"] = $PublicKey;
    $parameters["Version"] = $Version;
    $parameters["Service"] = "AWSECommerceService";
    ksort($parameters);
    $CanonicalizedQuery = array();
    foreach ($parameters as $data => $value) {
        $data = str_replace("%7E", "~", @rawurlencode($data));
        $value = str_replace("%7E", "~", @rawurlencode($value));
        $CanonicalizedQuery[] = $data . "=" . $value;
    }

    $CanonicalizedQuery = implode("&", $CanonicalizedQuery);
    $string_to_sign = $method . "\n" . $host . "\n" . $uri . "\n" . $CanonicalizedQuery;
    $signature = base64_encode(hash_hmac("sha256", $string_to_sign, $PrivateKey, True));
    $signature = str_replace("%7E", "~", rawurlencode($signature));
    $request = "http://" . $host . $uri . "?" . $CanonicalizedQuery . "&Signature=" . $signature;
    if (function_exists('curl_init')) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $request);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        $response = curl_exec($ch);
        if (!$response) {
            $return["error"]["message"] = __("Error By cURL Error Detail : ") . curl_errno($ch) . ": " . curl_error($ch);
            return $return;
        }
        curl_close($ch);
    } else {
        $response = @file_get_contents($request);
        if (!$response) {
            $return["error"]["message"] = __("Server Error : cURL is not exist on this server!");
            return $return;
        }
    }
//  CRT - This writes the response to a file for debugging purposes.  It is commented out, as it does expose the first part of the Amazon Product key pair.  If further support is needed, the comments would be removed.
/*    $myFile = dirname(__FILE__) . '/' . microtime() . 'response.xml';
	$fh = fopen($myFile, 'w') or die("can't open");
	fwrite($fh, $response);
	fclose($fh); */
    $Xml = simplexml_load_string($response);
    if ($Xml === False) {
        $emessage = __("Failed loading XML, errors returned: ");
        foreach (libxml_get_errors() as $error) {
            $emessage .= $error->message . ", ";
        }
        libxml_clear_errors();
        $return["error"]["message"] = $emessage;
        return $return;
    } else {
        return $Xml;
    }
}

function ama_create_post_posttables($intervaltype, $intervaltime, $category, $keyword, $postnow, $department, $numofpost, $AffiliateId, $cam_encoding=0, $browsenode=0, $CampaignID = 0, $minprice=0, $maxprice=0, $parent_page = 0, $asin_code = "", $camposttype="post", $postformat=1, $btnformat=1, $video=0, $similar_items, $similar_count, $no_desc, $custom_desc) {

    @ini_set('memory_limit', '256M');
    @set_time_limit(0);
    global $wpdb;
    $ytObject = new youTube();
    $htaccessurlbase = get_bloginfo('home');
    $sql_product = "select cam_camproductid from " . $wpdb->prefix . "ama_campaigns_post, `" . $wpdb->prefix . "posts` WHERE `post_ID` = `ID` AND `post_status` IN ('publish','future')"; // THIS QUERY RETURNS ALL ACTIVATED PRODUCT IDS SO WE CAN STOP REPEATED POTS.
    $productid = $wpdb->get_results($sql_product);
    $data_product = array();
    $count = 0;
    if ($productid) {
        foreach ($productid as $id) {
            $data_product[] = $id->cam_camproductid;
            $count++;
        }
    }
    $time = $intervaltime;
    $sql = "select * from " . $wpdb->prefix . "ama_option ";
    $api_data = $wpdb->get_results($sql);
    foreach ($api_data as $apidata) {
        $PublicKey = $apidata->api_key;
        $PrivateKey = $apidata->secret_api_key;
        $des_length = $apidata->amazon_des_length;
        $aff_web = $apidata->amazon_web;
    }
    $theCatId = get_term_by('name', $category, 'category');
    $category2 = $theCatId->term_id;
    $post_category = array($category2);
    $first_count = 0;
    $error_count = 0;
    $error_message = array();
    $product_error = "";
    $countpost = array();
    $finished = false;
    $apage = 1;
    $post_ID = 0;
    $pagecontent = "";
    $pageAsin = "";
    $alreadyPostedCount = 0;
    $noImage = 0;
    $noEditorialReview = 0;
    $noPriceListed = 0;
    $outofPriceRange = 0;
    if ($maxprice == 0 || $maxprice < $minprice) { $maxprice = 9000000; }
    do {
        $time_start = microtime(true);
        if(isset($runtime) && $runtime < 1) {
            $time_to_sleep = round((1 - $runtime) * 1000000) + 1;
            echo "<span style='font-size:8px'>. </span>";
            //echo "<br/>time_to_sleep = $time_to_sleep";
            usleep($time_to_sleep);
        }
        //usleep(1000000);
        if ($asin_code != "") {
            $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemLookup",
                "ItemId" => $asin_code,
                "ResponseGroup" => "EditorialReview,Similarities,Small,Request,OfferListings,Images",
                "AssociateTag" => $AffiliateId), $aff_web);
        } else {
            if ($department == "All") {
                $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                    "IdType" => "ASIN",
                    "MerchantId" => "All",
                    "ResponseGroup" => "EditorialReview,Similarities,Small,Request,OfferListings,Images,VariationSummary",
                    "SearchIndex" => $department,
		            "MinimumPrice" => $minprice*100,
            		"MaximumPrice" => $maxprice*100,
                    "Keywords" => $keyword,
                    "ItemPage" => $apage,
                    "AssociateTag" => $AffiliateId), $aff_web);
            } elseif ($browsenode != 0) {
                $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                    "IdType" => "ASIN",
                    "MerchantId" => "All",
                    "ResponseGroup" => "EditorialReview,Similarities,Small,Request,OfferListings,Images,VariationSummary",
                    "BrowseNode" => $browsenode,
                    "SearchIndex" => $department,
		            "MinimumPrice" => $minprice*100,
            		"MaximumPrice" => $maxprice*100,
                    "Keywords" => $keyword,
                    "ItemPage" => $apage,
                    "AssociateTag" => $AffiliateId), $aff_web);
            } else {
                $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                    "IdType" => "ASIN",
                    "MerchantId" => "All",
                    "ResponseGroup" => "EditorialReview,Similarities,Small,Request,OfferListings,Images,VariationSummary",
                    "SearchIndex" => $department,
                    "Keywords" => $keyword,
                    "ItemPage" => $apage,
		            "MinimumPrice" => $minprice*100,
            		"MaximumPrice" => $maxprice*100,
                    "AssociateTag" => $AffiliateId), $aff_web);
            }
        }
 if (isset($xml->Items->Request->Errors->Error->Code) || isset($xml->Error->Code) || isset($xml['error']['message'])) { //CRT - This is the correct way to grab the error code and error message from the $xml object
            if (isset($xml->Items->Request->Errors->Error->Code)) {
                if ($xml->Items->Request->Errors->Error->Code == 'AWS.InvalidAccount') {
                    $error_message['message'] = '<b>Your Amazon Associates Account is not set up for API use - Please go <a href="https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html" target="_blank">here</a> and complete the registration process.</b>'; }
                elseif ($xml->Items->Request->Errors->Error->Code == 'AWS.ECommerceService.NoExactMatches') {
                    $error_message['message'] = '<b>Amazon did not find any matches for your keyword in that category/node that are in your price range.  Please check them and try again.</b>'; }
                else {
                    $error_message['message'] = '<b>' . $xml->Items->Request->Errors->Error->Code . ' -- ' . $xml->Items->Request->Errors->Error->Message . '</b>'; }
            } elseif (isset($xml->Error->Code)) { // This is required because some responses are not as well formed as the others.
                if ($xml->Error->Code == 'SignatureDoesNotMatch') {
                    $error_message['message'] = '<b>There is an error in your Amazon API settings -- <a href="https://affiliate-program.amazon.com/gp/advertising/api/detail/your-account.html" target="_blank">Click here</a> to check your keys, and re-enter them on the <a href="/wp-admin/admin.php?page=amazone_setting">Amazon Settings page</a>.</b><br/>'; }
                else {
                    $error_message['message'] = '<b>' . $xml->Error->Code . ' -- ' . $xml->Error->Message . '</b><br/>'; }
            }
            else {
                $error_message['message'] = '<b>Host not found</b>';
            }
            $finished = true;
        } else {

            foreach ($xml->Items->Item as $item) {
                $LowestPrice = ama_getamazonprice($item);
                $pricetypearray = array('$', '?', 'EUR', ',', 'CDN', '?', "?");
                $price = (float) str_replace($pricetypearray, '', $LowestPrice);
                if ($maxprice <= 0) {$maxprice = 1000000;}
                if ((isset($item->EditorialReviews->EditorialReview->Content) || $no_desc) && isset($item->MediumImage->URL[0]) && !(in_array((string) $item->ASIN, $data_product)) && $LowestPrice != null ) {  // TODO && $price >= $minprice && $price <= $maxprice
                    if(($department == 'All') && $price < $minprice || $price > $maxprice) {
                        $outofPriceRange ++;
                        break;
                    }
                    if(!isset($item->EditorialReviews->EditorialReview->Content)) {
                        $descriptions = explode("|",$custom_desc);
                        $descriptionkey = array_rand($descriptions,1);
                        $item_description = trim($descriptions[$descriptionkey]);
                    }
                    if ($intervaltype == "day") {
                        $new_time = mktime(date("H"), date("i"), date("s"), date("m"), date("d") + $time, date("y"));
                    } elseif ($intervaltype == "hours") {
                        $new_time = mktime(date("H") + $time, date("i"), date("s"), date("m"), date("d"), date("y"));
                    } else {
                        $new_time = mktime(date("H"), date("i") + $time, date("s"), date("m"), date("d"), date("y"));
                    }
                    $time = $time + $intervaltime;
                    $post_date = date('Y-m-d H:i:s', $new_time);
                    $post_date_gmt = date('Y-m-d H:i:s', $new_time);
                    $post_status = 'future';
                    if ($postnow == "yes" && $first_count == 0) {
                        $post_status = 'publish';
                        $post_date = current_time('mysql');
                        $post_date_gmt = current_time('mysql', 1);
                        $first_count = 1;
                    }
                    $htacessurl = $htaccessurlbase . '/product/' . $item->ASIN . '/';
                    $post_title = $item->ItemAttributes->Title[0];
                    $items = explode(' ', $post_title);
                    $thetag = array();
                    for ($k = 0, $l = count($items); $k < $l; ++$k) {
                        $badtagcharacters = array(",", ".", "!", ":", "'", "\"", "(", ")", "[", "]", "?", "@", "#", "$", "*");
                        $potentialtag = ucfirst(str_replace($badtagcharacters, "", $items[$k]));
                        $long = strlen($potentialtag);
                        if (($long > 3) && ($potentialtag != 'With') && ($potentialtag != 'with'))  {
                            $thetag[] = $potentialtag;
                        }
                    }
                    $pageAsin.=(string) $item->ASIN . ',';
                    $tags_input = array($thetag[0], $thetag[1], $thetag[2], $thetag[3], $thetag[4], $thetag[5], $thetag[6], $thetag[7], $thetag[8], $thetag[9]);
                    $post_author = 1;
                    $post_data = compact('post_content', 'post_title', 'post_date', 'post_date_gmt', 'post_author', 'post_category', 'post_status', 'tags_input');
                    $post_data = add_magic_quotes($post_data);
                    if ($camposttype == "page") {
                        if ($parent_page > 0) {
                            $page = array();
                            $page['ID'] = $parent_page;
                            $page['post_content'] = "";
                            wp_update_post($page);
                            update_post_meta($parent_page, '_amazon_asin_key', trim($pageAsin, ','));
                            update_post_meta($parent_page, '_amazon_campid', $CampaignID);
                            update_post_meta($parent_page, 'amazon_postformat', $postformat);
                            update_post_meta($parent_page, 'amazon_buttonformat', $btnformat);
                        }
                    } elseif ($camposttype == "post") {
                        $post_ID = wp_insert_post($post_data);
                        $asin = (string) $item->ASIN;
                        if (isset($item->EditorialReviews->EditorialReview->Content))
                            $des = (string) strip_tags($item->EditorialReviews->EditorialReview->Content[0]);
                        elseif (isset($item_description))
                            $des = $item_description;
                        update_post_meta($post_ID, '_amazon_asin_key', $asin);
                        update_post_meta($post_ID, '_amazon_campid', $CampaignID);
                        update_post_meta($post_ID, 'amazon_postformat', $postformat);
                        update_post_meta($post_ID, 'amazon_buttonformat', $btnformat);
                        update_post_meta($post_ID, 'amazon_description', $des);
                        update_post_meta($post_ID, 'amazon_image_alt', (string) $item->ItemAttributes->Title);
                        if($similar_items == "yes" ) {
                            $similarProductCount = 0;
                            if(isset($item->SimilarProducts->SimilarProduct)) {
                                foreach($item->SimilarProducts->SimilarProduct as $similarProduct) {
                                    $similarProductCount = $similarProductCount + 1;
                                    //echo "$similarProductCount - $similar_count";
                                    if($similarProductCount > $similar_count) break;
                                    //$similarProductASIN .= (string) "<li><a href='http://amazon.com/dp/" . $similarProduct->ASIN . "%3FSubscriptionId%3DAKIAJNYMUKZMETKK6T5Q%26tag%3Dmanidad-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D" . $similarProduct->ASIN ."'>" . $similarProduct->Title . "</a></li>\n";
                                    $sql = "INSERT INTO " . $wpdb->prefix . "ama_similar(asin,aurl,cloakedurl,mainproduct,title)VALUES('" . $similarProduct->ASIN . "','http://amazon.com/dp/" . $similarProduct->ASIN . "%3FSubscriptionId%3D" . $PublicKey . "%26tag%3D". $AffiliateId . "%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3D" . $similarProduct->ASIN ."','" . get_bloginfo('home') . "/product/s" . $similarProduct->ASIN . "/','". $asin . "','" . $similarProduct->Title . "')";
                                    $wpdb->query($sql);
                                }
                            }
                        }

                        if ($video == 1) {

                            if ($ytObject->search((string) $item->ItemAttributes->Title, 2)) {
                                if (count($ytObject->RKT_requestResult->entry) > 0) {
                                    $videoid = "";
                                    foreach ($ytObject->RKT_requestResult->entry as $videodata) {
                                        $arrvideo = explode('video:', $videodata->id);
                                        if ($arrvideo && is_array($arrvideo) && isset($arrvideo[1]) && $videoid == "") {
                                            $videoid = "http://www.youtube.com/embed/" . $arrvideo[1];
                                        }
                                    }
                                    if ($videoid != "") {
                                        update_post_meta($post_ID, '_amazon_youtube_url', $videoid);
                                        update_post_meta($post_ID, 'amazon_youtube_keyword', (string) $item->ItemAttributes->Title);
                                    }
                                }
                            }
                        }
                    }
                    $countpost[] = array('ASIN' => $item->ASIN, 'post_ID' => $post_ID);
                    $content = trim(strip_tags($item->EditorialReviews->EditorialReview->Content[0]));
                    if($item->Offers->TotalOffers == 0) {
                        $buylink = $item->DetailPageURL;
                    } else {
                        $buylink = 'http://www.amazon.' . $aff_web . '/gp/aws/cart/add.html?ASIN.1=' . $item->ASIN . '&Quantity.1=1&AssociateTag=' . $AffiliateId . '&AWSAccessKeyID=' . $PublicKey;
                    }
                    $arrayInsert = array(
                        'campid' => $CampaignID,
                        'asin' => $item->ASIN,
                        'title' => $item->ItemAttributes->Title[0],
                        //'link' => $item->DetailPageURL,
                        'link' => $buylink,
                        'price' => $LowestPrice,
                        'timestamp' => '',
                        'des' => $content,
                        'imgurl' => $item->MediumImage->URL[0],
                        'clockurl' => $htacessurl,
                        'web' => $aff_web,
                        'affid' => $AffiliateId
                    );
                    ama_save_campaign($arrayInsert, "ama_camp_prodata");
                    if (count($countpost) >= $numofpost) {
                        $breck = true;
                        $finished = true;
                        break;
                    }
                } else {
                    //echo "<br/><a href='$item->DetailPageURL'>Item</a>";
                    //echo "<br/>Rejected because: ";
                    if(!isset($item->EditorialReviews->EditorialReview->Content) && !$no_desc) $noEditorialReview ++;
                    if(!isset($item->MediumImage->URL[0])) $noImage ++;
                    if(in_array((string) $item->ASIN, $data_product)) $alreadyPostedCount ++;
                    if($LowestPrice == null) $noPriceListed ++;
                    if($department == "All" && $price < $minprice || $price > $maxprice) $outofPriceRange ++;
                    //print_r($item);
                    //echo "<hr>";

                }
            }
            if ($department == 'All' && $apage > 4) {
                    $finished = true;
            }
            if ($department != 'All' && $apage > 9) {
                    $finished = true;
            }
        }
        if ($department == 'All' && $apage > 4) {
            $finished = true;
        }
        if ($department != 'All' && $apage > 9) {
            $finished = true;
        }
        $apage++;
        $time_end = microtime(true);
        $runtime = $time_end - $time_start;

        //echo "<br />time_end = $time_end<br/>Page $apage took $runtime seconds<br />";
    } while (!($finished));
    if(!$no_desc) $error_message['noEditorial'] = $noEditorialReview;
    $error_message['noImage'] = $noImage;
    $error_message['alreadyPosted'] = $alreadyPostedCount;
    $error_message['noPrice'] = $noPriceListed;
    $error_message['outofPriceRange'] = $outofPriceRange;
    $error_message['num_post'] = count($countpost);
    if (count($countpost) == 0 && count($error_message) == 0 && !(isset($error_message['message']))) {
        $error_message['message'] = $xml->Items->Request->Errors->Error->Code . ' - ' . 	$xml->Items->Request->Errors->Error->Message; // CRT - Again, we are getting the error code and error message from the object.
    }
    if (!isset($error_message['message'])) {
        for ($i = 0; $i < count($countpost); $i++) {
            $sql_insert = "insert into " . $wpdb->prefix . "ama_campaigns_post(cam_postid,cam_camid,cam_camproductid,post_ID,cam_capiid)values(null,'" . $CampaignID . "','" . $countpost[$i]['ASIN'] . "','" . $countpost[$i]['post_ID'] . "','" . $AffiliateId . "')";
            $wpdb->query($sql_insert);
            if ($cam_encoding != 0) {
                $sql = "INSERT INTO " . $wpdb->prefix . "ama_uniquepost(postid,campid)VALUES('" . $countpost[$i]['post_ID'] . "','" . $CampaignID . "')";
                $wpdb->query($sql);
            }
        }
    }
    return $error_message;
}

require_once('ama_create_similar_posttables.php');

function ama_save_campaign($savedata, $tablename) {
    global $wpdb;
    $tablename = $wpdb->prefix . $tablename;
    $wpdb->insert($tablename, $savedata);
    return mysql_insert_id();
}

function ama_getamazonprice($xmlobj) {
    $ListPrice = null;
    $LowestPrice = null;
    $ListPrice = $xmlobj->Offers->Offer->OfferListing->Price->FormattedPrice; // 2.0 style price
    if ($LowestPrice == null) {
        $LowestPrice = $ListPrice; // 2.0 style price
    }
    if ($LowestPrice == null) {
        $LowestPrice = $xmlobj->ItemAttributes->ListPrice->FormattedPrice;
    }
    if ($LowestPrice == null) {
        $LowestPrice = $xmlobj->OfferSummary->LowestUsedPrice->FormattedPrice;
    }

    if ($LowestPrice == null) {
        $LowestPrice = $xmlobj->OfferSummary->LowestNewPrice->FormattedPrice;
    }

    if ($LowestPrice == null) {
        $LowestPrice = $xmlobj->OfferSummary->LowestNewPrice->FormattedPrice;
    }

    if ($LowestPrice == null) {
        $LowestPrice = $xmlobj->VariationSummary->LowestPrice->FormattedPrice;
    }
    if ($LowestPrice == null) {
        $LowestPrice  = $xmlobj->VariationSummary->HighestPrice->FormattedPrice;
    }
    if ($LowestPrice == null)
        $LowestPrice = $ListPrice;

    return str_replace('?', "", $LowestPrice);
}

add_action('edit_post', 'ama_update_youtube_video');

function ama_update_youtube_video($post_ID) {
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
        return;
    $youMetavalue = get_post_meta($post_ID, 'amazon_youtube_keyword', true);
    $ytObject = new youTube();
    if ($youMetavalue) {
        if ($ytObject->search($youMetavalue, 2)) {
            if (count($ytObject->RKT_requestResult->entry) > 0) {
                $videoid = "";
                foreach ($ytObject->RKT_requestResult->entry as $video) {
                    $arrvideo = explode('video:', $video->id);
                    if ($arrvideo && is_array($arrvideo) && isset($arrvideo[1]) && $videoid === "") {
                        $videoid = "http://www.youtube.com/embed/" . $arrvideo[1];
                    }
                }
            }
        }
        if ($videoid != "") {
            update_post_meta($post_ID, '_amazon_youtube_url', $videoid);
        }
    }
}

